import * as squint_core from 'squint-cljs/core.js';
import { StateField, StateEffect, EditorState } from '@codemirror/state';
import * as cm_view from '@codemirror/view';
import { EditorView, WidgetType } from '@codemirror/view';
import { Plugin, PluginKey } from 'prosemirror-state';
import { Decoration, DecorationSet } from 'prosemirror-view';
import * as Y from 'yjs';
import { WebsocketProvider } from 'y-websocket';
import { absolutePositionToRelativePosition, relativePositionToAbsolutePosition, ySyncPlugin, ySyncPluginKey, yCursorPlugin, setMeta, defaultCursorBuilder, defaultSelectionBuilder } from 'y-prosemirror';
import * as blank_cm from './../codemirror.mjs';
var key = new PluginKey("blank.collab");
var RemoteCursor = function (p__11) {
let map__12 = p__11;
let user3 = squint_core.get(map__12, "user");
let key4 = squint_core.get(map__12, "key");
let this$5 = this;
return squint_core.assoc_BANG_(this$5, "key", key4, "compare", (function (other) {
return (key4) === (other.key)
}), "eq", (function (other) {
return (key4) === (other.key)
}), "updateDOM", squint_core.constantly(true), "destroy", (function () {
return null
}), "toDOM", (function (view) {
return defaultCursorBuilder(user3)
}))
};
var pm__GT_cm_deco = function (p__12) {
let map__12 = p__12;
let from3 = squint_core.get(map__12, "from");
let to4 = squint_core.get(map__12, "to");
let spec5 = squint_core.get(map__12, "spec");
let map__67 = spec5;
let key8 = squint_core.get(map__67, "key");
let user9 = squint_core.get(map__67, "user");
if (squint_core.truth_((function () {
 let and__23420__auto__10 = key8;
if (squint_core.truth_(and__23420__auto__10)) {
return user9} else {
return and__23420__auto__10}
})())) {
return cm_view.Decoration.widget(({ "widget": new RemoteCursor(spec5), "key": key8 })).range(from3, to4)} else {
return null}
};
var cm_cursor_state = StateField.define(({ "provide": (function (field) {
return EditorView.decorations.from(field)
}), "create": (function (_state) {
return cm_view.Decoration.none
}), "update": (function (decos, p__13) {
let map__12 = p__13;
let _tr3 = map__12;
let effects4 = squint_core.get(map__12, "effects");
let temp__23035__auto__5 = squint_core.some((function (_PERCENT_1) {
if (squint_core.truth_(_PERCENT_1.is(blank_cm.forward_decorations))) {
return _PERCENT_1.value}
}), effects4);
if ((temp__23035__auto__5 == null)) {
return decos} else {
let map__67 = temp__23035__auto__5;
let pm_decorations8 = squint_core.get(map__67, "pm-decorations");
return cm_view.Decoration.set(squint_core.keep(pm__GT_cm_deco, pm_decorations8))}
}) }));
var names = ["Bean", "Luci", "Elfo", "Zøg", "Ursula", "Oona", "Dagmar", "Pendergast", "Odval", "Merkimer"];
var colors = ["#fed7aa", "#bef264", "#a7f3d0", "#67e8f9", "#0891b2", "#bfdbfe", "#f0abfc", "#fda4af", "#f43f5e", "#fde68a"];
var rand_nth = function (a) {
return squint_core.get(a, Math.trunc((a.length) * (Math.random())))
};
var init_state = function (p__14) {
let map__12 = p__14;
let doc_name3 = squint_core.get(map__12, "doc-name", "blank");
let host4 = squint_core.get(map__12, "host", "localhost");
let port5 = squint_core.get(map__12, "port", 1234);
let name6 = squint_core.get(map__12, "name", rand_nth(names));
let color7 = squint_core.get(map__12, "color", rand_nth(colors));
let y_doc8 = new Y.Doc();
let y_ws9 = new WebsocketProvider(squint_core.str("ws://", host4, ":", port5), doc_name3, y_doc8);
let y_awareness10 = (function () {
 let G__1511 = y_ws9.awareness;
G__1511.setLocalStateField("user", ({ "name": name6, "color": color7 }));
return G__1511
})();
let y_xml_fragment12 = y_doc8.getXmlFragment("prosemirror");
return ({ "awareness": y_awareness10, "plugins": [ySyncPlugin(y_xml_fragment12), yCursorPlugin(y_awareness10)] })
};

export { key, RemoteCursor, pm__GT_cm_deco, cm_cursor_state, names, colors, rand_nth, init_state }
